# 2013N521ǗC szz֐t@CiRgtj
# [f[^̂߂̊֐(v_NVfj
SPobs <- function(r, K, B1, E, q, sigma, nyear=50){
  B <- numeric()
  B[1] <- B1
  for(i in 2:nyear){ 
    B[i] <- B[i-1] + r*(1-B[i-1]/K)*B[i-1] - E[i-1]*B[i-1]
  }
  C.obs <- E*B
  # [CPUEf[^ACPUE=qBƂč쐬Blog(CPUE)̊ϑ덷𕽋ςOASD=sigma̐Kz(rnorm)ƂĂ̂ŁAexp(rnorm())悶Ă
  # rnorm()̊֐̍ŏ̈́ACPUEf[^̒Ȃ̂ŁAlength(C.obs)͒Pnyear̂قK؂ȂB
  cpue.obs <- B * q * 
          exp(rnorm(length(C.obs), mean=0, sd=sigma))
  # ʂXgƂĊi[
  res <- list(B=B, E=E, C.obs=C.obs, cpue.obs=cpue.obs)

  # ʂ̃NX"SPobs"ƒ`BƁAplot.NX@Ƃ֐`ƂɁiłplot.SPobs)ASPobsȗplot(res)ƂŁAplot.SPobss邱Ƃł̂ŁAAB
  class(res) <- "SPobs"
  return(res)
}


# CPUE̗\lvZ֐
SPexp <- function(pars, what.est, init, data, nyear=50, B1eqK=FALSE,out=FALSE){ 
  # pars : r, log(K), log(B1)@ɑΉ钷R̃xNg
  # wat.est : ̂R̂Ԗڂ̃p[^𐄒肷邩H
  # init : 肷Ƃ̏lŒR̃xNgBAΉp[^𐄒肵ȂꍇAɗ^ꂽlgČvZsB
  # B1eqK : B1K𓯂Ɖ肷邩Hiu`ł͎g܂łAv_NVfgƂ́ẢƂɂĐ肪肷̂ŁA悭̉肪邱Ƃj
  C.obs <- data$C.obs
  cpue.obs <- data$cpue.obs
  tmp <- init
  tmp[what.est] <- pars

  r <- tmp[1]    
  K <- exp(tmp[2])  # XP[Ɛ肪̂ŁAK̂log_K𐄒肷
  B1 <- exp(tmp[3])@# ƓlBƁA{rɐ肵قǂ̂ŁAlog_r𐄒肷ׂłB̂Ƃ͂RRs r <- exp(tmp[1])ƂĂB
  if(B1eqK==TRUE) B1 <- exp(tmp[2]) # B1=K̉Ƃ
#  q <- exp(tmp[4])

  # ̂ւ͍u`ł̂Ɠ
  B <- numeric()
  B[1] <- B1
  for(i in 2:nyear){
    B[i] <- B[i-1] + r*(1-B[i-1]/K)*B[i-1] - C.obs[i]
    B[i] <- ifelse(B[i]<0,0.001,B[i])  # BɂȂꍇAȐ0.001ɒu
  }
  ncpue <- sum(!is.na(cpue.obs))
  q <- exp(1/ncpue* log(cpue.obs/B)) # ΐKž덷肵ĂꍇAqexp(1/n * log(cpue/B))Ƃĉ͓Iɋ߂
  
  cpue.exp <- q * B # ^ꂽp[^ pars ̂ƂłCPUE̊Ғl
  if(out==TRUE){ # \l̂܂܏o͂Ƃ͂îɁApredict.SPobs Ŏgj
    res <- list(B=B, C.obs=C.obs, E=E, cpue.exp=cpue.exp)
    class(res) <- "SPobs"
    return(res)
  }
  else{@ # ϑlicpue.obs)Ƃ̓ao͂ƂîɁAoptimŎgj
    return(sum((log(cpue.exp)-log(cpue.obs))^2,na.rm=T))
  }
}

# v_NVfŃp[^𐄒肷֐
SPest <- function(what.est, data, # ̈͂قƂSPexpɈpBAA킩₷̂߁Al͕ϐϊO̎XP[ŗ^Ă
                  init=c(0.3,1000,1000),B1eqK=FALSE){
  init2 <- init
  init2[2:3] <- log(init[2:3])
  res <- optim(init2[what.est], # ŏ̎sBSPexpɂUVVOsڂ̈^̕ԂliCPUE̗\lƊϑl̓ajŏɂp[^̃ZbgiSPexpparsŗ^钷R̃xNgjԂ
               SPexp,
               what.est=what.est,
               data=data,
               B1eqK=B1eqK,
               init=init2,
	             control=list(maxit=10000)) # ŏASY̐ݒBJԂvZ܂Ŏ{邩HftHg͂TOOBŐݒ肳ꂽ񐔂̌vZĂȂiK؂ȃp[^łȂjꍇ͌vZ߂B̏ꍇAԂlconvergence͂PƂȂB
  res$summary <- data.frame(init=init,est=NA) # ʂ̗v̂߂̃f[^t[ (init͏lAest͐lj
  res$summary$est[what.est] <- res$par # l optim̕Ԃĺ@res$par <- 肳ꂽp[^
  res$summary$est[2:3] <- exp(res$summary$est[2:3]) # XP[ɖ߂
  rownames(res$summary) <- c("r","K","B1")
  res$init2 <- init2
  class(res) <- "SPest" # NXSPestƒ`
  res$data <- data
  return(res)
}

#------ ȉApredict.SPestprint.SPest͏̊֐ SPest̕ԂliSPestƂNXIuWFNgjp̊֐
#------ SPestƂNXÕIuWFNgɓꍇApredict.SPest ܂ print.SPest@ 'SPest'@ȗł
# G
# a <- SPest(Ȃ񂩂̈)  # a"SPest"ƂNX
# predict(a)  # SPestȗĂAIɂpredict.SPestƂ֐ĂяoĂ
# predict.SPest(a) # ̍sƏ̍s͑SʂԂ
# \ľvZ

# SPest̕Ԃl玑ʂCPUEȂǂ̗\lvZ֐(SPexp̈SPest̕ԂlŎw肷邾̊֐j
predict.SPest <- function(res,out=TRUE){
  tmp <- SPexp(res$par,what.est=which(!is.na(res$summary$est)),
         init=res$init2,data = res$data,out=out) 
  tmp$summary <- res$summary
  return(tmp)
}

# SPesťʂ₷邽߂̊֐BȂĂ悩AAB
#  ̊֐`ĂƁA
#  a <- SPest(Ȃ񂩂̈j
#  a 
#  ƂƂAa̒głȂAprint(round(a$summary,3)) ̌ʂo͂悤ɂȂ
print.SPest <- function(res){
  print(round(res$summary,3))
}

#------ SPobsƂNXIuWFNgp̊֐
# Ɠl 
# a <- SPobs(Ȃ񂩂̈)  # a"SPobs"ƂNX
# plot(a)  # SPobsȗĂAIɂplot.SPobsƂ֐ĂяoĂ
# plot.SPobs(a) # ̍sƏ̍s͑SʂԂ

# f[^\l̃vbg
plot.SPobs <- function(res){
  plot(res$B,type="b",ylab="Biomass",ylim=c(0,max(res$B,res$cpue)))
  points(res$C.obs,type="b",pch=2,col=2)
  points(res$cpue,yaxt="n",xaxt="n",pch=3,col=3,ylim=c(0,max(res$cpue)),xlab="",ylab="")
  legend("topright",col=1:3,pch=1:3,legend=c("Biomass","Catch","CPUE"))
}

#-----------------------------------------------------------------------------
#---------------- [f[^֐iN\fj
#-----------------------------------------------------------------------------

ASobs <- function(nage=10,nyear=50,
                  F=c(seq(from=0.2,to=0.5,length=40),rep(0.5,10)),# N\fłAP̂F͑SNƉ肵܂B
                  M=0.3,
                  R0=1000,maturity=c(rep(0,4),rep(1,6)),h=0.7,Rsigma=0,sigma=0.2){

  N <- C <- matrix(0,nage,nyear) # NʔƋl邽߂̍s
  dimnames(C) <- dimnames(N) <- list(1:nage,1:nyear)

  #@PNڂ̔vZBł́AƂȂ̏ꍇ̋lAƐ܂Aۂ͍ŏ̔NFɂ镽tԂ肷悤ȃR[hɂȂĂ܂BꂾƁAS0̌vZԈႤ̂ŁAPRUsڂRgAEgĂPRVsڂ̂悤ɏ܂B
  N.init <- numeric()
  N.init[1] <- R0 # ƂȂ̂Ƃ̉R0
#  for(i in 2:(nage-1))  N.init[i] <- N.init[i-1]*exp(-M-F[1])@# ŏ̔N͍ŏ̔NFiԈႢj
  for(i in 2:(nage-1))  N.init[i] <- N.init[i-1]*exp(-M) # ŏ̔N͋ƂȂij
  N.init[nage] <- N.init[nage-1]/(1-exp(-M)) # vXO[v͓̔䋉̘ǎvZ
  S0 <- sum(N.init * maturity) # ƂȂ̏Ԃ̂Ƃ̐e̎

  # eq֌ẂAƂȂ̂Ƃ̐e̎ʁiS0)ƉʁiR0)AXiAeS01/5ɂȂƂʂɂȂ邩ƂljvZ
  beverton <- function(h,S0,R0,ssb,sigma=0){
    4*h*R0*ssb/(S0*(1-h)+ssb*(5*h-1)) * exp(rnorm(length(ssb),mean=-0.5*(sigma)^2,sd=sigma))
  }

  # Nڂ͂vZN.initg
  N[,1] <- N.init
  for(i in 2:nyear){ #QNڈȍ~
    for(j in 2:(nage-1)){  # 2΂nage-1΂܂
      N[j,i] <- N[j-1,i-1] * exp(-F[i-1]-M)
    }
    N[nage,i] <- N[nage,i-1] * exp(-F[i-1]-M) + N[nage-1,i-1] * exp(-F[i-1]-M)
    N[1,i] <- beverton(sum(N[,i] * maturity),h=h,S0=S0,R0=R0,sigma=Rsigma)@# ͂̔N̐eʂƐeq֌WvZ
  }

  for(i in 1:nyear){
    C[,i] <- F[i]/(F[i]+M)*N[,i]*(1-exp(-F[i]-M)) # lNʋlʂvZ
  }
  cpue.obs <- colSums(N)*exp(rnorm(nyear,0,sigma)) # CPUE̊ϑlvZ
  
@# Ԃľ`SPobsƋʂiBACƂj邱ƂɂSPobspɗpӂvbg֐iplot.SPobs)g
  res <- list(B=colSums(N),C.obs=colSums(C),cpue.obs=cpue.obs,naa=N,caa=C)
  class(res) <- "SPobs"
  return(res)
}


